#include "ViEditView.h"

ViEditView::ViEditView(QWidget *parent)
	: m_mode(CMD), QPlainTextEdit(parent)
{
    connect(this, SIGNAL(cursorPositionChanged()), this, SLOT(onCursorPositionChanged()));
}

ViEditView::~ViEditView()
{

}
void ViEditView::keyPressEvent ( QKeyEvent * event )
{
	switch( mode() ) {
	case CMD:
		cmdModeKeyPressEvent(event);	//	R}h[h̏ꍇ̏
		break;
	case INSERT:
		insModeKeyPressEvent(event);	//	}[h̏ꍇ̏
		break;
	}
}
void ViEditView::cmdModeKeyPressEvent(QKeyEvent *event)
{
	QString text = event->text();
	if( text == "i" ) {
		setMode(INSERT);	//	i ꂽ}[h
		return;
	}
}
void ViEditView::insModeKeyPressEvent(QKeyEvent *event)
{
	if( event->key() == Qt::Key_Escape ) {
		setMode(CMD);		//	Esc ꂽR}h[h
		return;
	}
	QPlainTextEdit::keyPressEvent(event);
}
#if 0
QString ViEditView::modeString() const
{
	switch( mode() ) {
	case CMD:		return "CMD";
	case INSERT:	return "INSERT";
	}
	return "";
}
#endif
void ViEditView::setMode(Mode mode)
{
	if( mode != m_mode ) {
		m_mode = mode;
		emit modeChanged();
		onCursorPositionChanged();
	}
}
void ViEditView::onCursorPositionChanged()
{
	if( mode() == ViEditView::CMD ) {
		QTextCursor cur = textCursor();
		cur.movePosition(QTextCursor::Right, QTextCursor::KeepAnchor);
		QString text = cur.selectedText();
		QChar ch = text.isEmpty() ? QChar(' ') : text[0];
		int wd = fontMetrics().width(ch);
		if( !wd )
			wd = fontMetrics().width(QChar(' '));
		setCursorWidth(wd);
	} else
		setCursorWidth(1);
}
