#ifndef VIEDITVIEW_H
#define VIEDITVIEW_H

#include <QPlainTextEdit>

class ViEditView : public QPlainTextEdit
{
	Q_OBJECT

public:
	enum Mode {
		CMD = 0,
		INSERT,
	};

public:
	ViEditView(QWidget *parent = 0);
	~ViEditView();

public:
	Mode	mode() const { return m_mode; }
	//QString	modeString() const;

public:
	void	setMode(Mode mode);

public slots:
	void	onCursorPositionChanged();

protected:
	void	keyPressEvent ( QKeyEvent * event );
	void	cmdModeKeyPressEvent(QKeyEvent *);
	void	insModeKeyPressEvent(QKeyEvent *);

signals:
	void	modeChanged(/*Mode*/);

private:
	Mode	m_mode;
};

#endif // VIEDITVIEW_H
