#include <QtGui>
#include "mainwindow.h"
#include "ViEditView.h"

MainWindow::MainWindow(QWidget *parent, Qt::WFlags flags)
	: QMainWindow(parent, flags)
{
	m_editor = new ViEditView;
	setCentralWidget(m_editor);

	connect(m_editor, SIGNAL(modeChanged()), this, SLOT(onModeChanged()));
	onModeChanged();
}

MainWindow::~MainWindow()
{

}

void MainWindow::onModeChanged(/*ViEditView::Mode mode*/)
{
	QString text;
	switch( m_editor->mode() ) {
	case ViEditView::CMD:
		text = "CMD";
		break;
	case ViEditView::INSERT:
		text = "INSERT";
		break;
	}
	statusBar()->showMessage(text);
}
